USE [TRENDTEX]
GO

/****** Object:  UserDefinedFunction [dbo].[PMX_FN_GetCreditBalance_V1]    Script Date: 2018-09-12 4:31:06 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO




--[RA-]


CREATE FUNCTION [dbo].[PMX_FN_GetCreditBalance_V1]
(

)
RETURNS @tbl TABLE ( 
PLPLDocEntry INT,
soDocEntry INT,
CardCode NVARCHAR(50),
ShipToAddress NVARCHAR(100),
U_V33_ShipFrequency NUMERIC(19,6),
U_Completion NVARCHAR(100),
U_V33_NotReqd NUMERIC(19,6),
U_V33_AsPossible NUMERIC(19,6),
U_V33_Complete NUMERIC(19,6),
U_V33_BO_Min NUMERIC(19,6),
soCompletion NUMERIC(19,6),
plQuantity NUMERIC(19,6),
TotalQuantity NUMERIC(19,6),
soCount NUMERIC(19,6),
SumNumOfBolts NUMERIC(19,6),
ShipDate date,
GroupNum INT,
CreditLine  NUMERIC(19,6),
CreditBalance  NUMERIC(19,6),
soOpenSum  NUMERIC(19,6),
LastShipDate date,
LastDocnum INT,
PicklistDocentry NVARCHAR(100),
CreditBalance_Running NUMERIC(19,6),
creditOK          NVARCHAR(1),
sumNumBolts INT

) AS
BEGIN


DECLARE  @ShippableOrders TABLE( 
PLPLDocEntry INT,
soDocEntry INT,
CardCode NVARCHAR(50),
ShipToAddress NVARCHAR(100),
U_V33_ShipFrequency NUMERIC(19,6),
U_Completion NVARCHAR(100),
U_V33_NotReqd NUMERIC(19,6),
U_V33_AsPossible NUMERIC(19,6),
U_V33_Complete NUMERIC(19,6),
U_V33_BO_Min NUMERIC(19,6),
soCompletion NUMERIC(19,6),
plQuantity NUMERIC(19,6),
TotalQuantity NUMERIC(19,6),
soCount NUMERIC(19,6),
SumNumOfBolts NUMERIC(19,6),
ShipDate date,
GroupNum  INT,
CreditLine  NUMERIC(19,6),
CreditBalance  NUMERIC(19,6),
soOpenSum  NUMERIC(19,6),
LastShipDate date,
LastDocnum INT,
PicklistDocentry NVARCHAR(100),
 PRIMARY KEY ( PLPLDocEntry ) )





 INSERT @ShippableOrders
SELECT DISTINCT "PMX_PLPL"."DocEntry", "ORDR"."DocEntry" AS "soDocEntry", "PMX_PLPH"."CardCode", "PMX_PLPH"."ShipToAddress"
,coalesce("OCRD"."U_V33_ShipFrequency", OCRDPDMX."U_V33_ShipFrequency") as "U_V33_ShipFrequency"
,isnull(ORDR.U_Completion, 'Not Required') as "U_Completion"
, coalesce("OCRD"."U_V33_NotReqd", OCRDPDMX."U_V33_NotReqd") as "U_V33_NotReqd"
, coalesce("OCRD"."U_V33_AsPossible", OCRDPDMX."U_V33_AsPossible") as "U_V33_AsPossible"
, coalesce("OCRD"."U_V33_Complete", OCRDPDMX."U_V33_Complete") as "U_V33_Complete"
, coalesce("OCRD"."U_V33_BO_Min" , OCRDPDMX."U_V33_BO_Min" ) as "U_V33_BO_Min" 
, "SumSO"."soCompletion"
--,PMX_PLPL.PickListQuantity 
,SumSO.plQuantity
,SumSO.TotalQuantity
,SumSO.soCount
,"SOVALUE".NumOfBolts
, "RDR1"."ShipDate"

----if payment term is creditcard, overwrite creditline to 20000
---- no longer valid = michael asked to revert on 20180703
,OCRD.GroupNum
,CASE OCRD.GroupNum
  WHEN 12 THEN ocrd.CreditLine
  ELSE ocrd.CreditLine
END as CreditLine
----------------------------
, isnull(ocrd.Balance + ocrd.DNotesBal + isnull(DRAFTCUST.DocTotal,0),0) as "CreditBalance"
 ,"SOVALUE".soOpenSum
 , isnull(del.ShipDate,'') as LastShipDate
 ,ISNULL(DEL.Docnum, -1) as LastDocnum
 ,isnull(PMX_PLHE.DocEntry, -1) as PicklistDocentry
 

FROM "PMX_PLPL"
INNER JOIN "PMX_PLPH" ON "PMX_PLPL"."DocEntry" = "PMX_PLPH"."DocEntry"
INNER JOIN "OCRD" ON "PMX_PLPH"."CardCode" = "OCRD"."CardCode"
INNER JOIN "ORDR" ON "PMX_PLPL"."BaseEntry" = "ORDR"."DocEntry" AND "PMX_PLPL"."BaseType" = N'17'
INNER JOIN "RDR1" on "RDR1"."DocEntry" = "ORDR"."DocEntry"
INNER JOIN OCRD OCRDPDMX ON OCRDPDMX.CardCode = 'PDMX'
LEFT JOIN "PMX_PLHE" ON PMX_PLPH."DocEntry" = "PMX_PLHE"."PickListProposalEntry"
LEFT JOIN "PMX_WAVE" ON "PMX_PLHE"."WaveKey" = "PMX_WAVE"."InternalKey"

--based upon lines
INNER JOIN 
	(SELECT "RDR1"."DocEntry", COUNT(*) AS "soCount", 
	count(pmx_PLPL.LineNum) AS "plQuantity", 
	count(rdr1.linenum) AS "TotalQuantity", 
	convert(decimal(19,2), (convert(decimal(19,2),count(pmx_PLPL.LineNum))/convert(decimal(19,2),count(rdr1.linenum)) * 100)) AS "soCompletion"
	,sum(rdr1.opensum) as soOpenSum 
	FROM "RDR1" 
	left JOIN "PMX_PLPL" ON "RDR1"."DocEntry" = "PMX_PLPL"."BaseEntry" AND "RDR1"."LineNum" = "PMX_PLPL"."BaseLine" AND "PMX_PLPL"."LineStatus" = 'O' 
	GROUP BY "RDR1"."DocEntry") AS "SumSO" ON "SumSO"."DocEntry" = "ORDR"."DocEntry"

INNER JOIN 
	(SELECT sum(rdr1.opensum) as soOpenSum, pmx_plpl.DocEntry , sum(rdr1.U_NUMBOLT) as NumOfBolts
	FROM "RDR1" 
	inner JOIN "PMX_PLPL" ON "RDR1"."DocEntry" = "PMX_PLPL"."BaseEntry" AND "RDR1"."LineNum" = "PMX_PLPL"."BaseLine" AND "PMX_PLPL"."LineStatus" = 'O' 
	GROUP BY pmx_plpl.DocEntry) AS "SOVALUE" ON "SOVALUE"."DocEntry" = "PMX_PLPL"."DocEntry"

Left join
	(select isnull(max(odln.DocDueDate),'') as ShipDate, DLN1.BaseRef, isnull(max(ODLN.DocNum),0) as Docnum from dln1
	left join odln on odln.DocEntry = dln1.DocEntry
	group by DLN1.BaseRef 
	) as DEL on DEL.Baseref = "ORDR"."DocEntry"

Left join
	(select isnull(max(odln.DocDueDate),'') as ShipDate, odln.CardCode from odln
	group by odln.CardCode
	) as DELCUST on DELCUST.cardcode = "ORDR".CardCode

Left join
	(select isnull(max(ODRF.DocDueDate),'') as ShipDate, ODRF.CardCode, sum(ODRF.DocTotal) as DocTotal from ODRF
	where odrf.ObjType = '15' and ODRF.DocStatus <> 'C'
	group by ODRF.CardCode
	) as DRAFTCUST on DRAFTCUST.cardcode = "ORDR".CardCode

	


WHERE 	"ORDR"."DocStatus" = 'O' AND "PMX_PLPL"."LineStatus" = 'O' and isnull(OCRD.U_V33_USE_PDMX, 'Y') = 'Y'
	and OCRD.frozenFor = 'N'
	and isnull("OCRD"."U_V33_CREDITAPPV",'N') = 'Y' 
	--only create pl if shipdate is in the past or between now and 10 days - 20180627
	and ORDR.DocDueDate <= GETDATE()+10 
	--=> if there is a dlivery for that customer only ship if its in the min ship freq.
	and 
		--=> shipfreq needs to check latest shipment date draft and delivery it is possible the last draft was 4 days ago but last del was 1 day so then check del.
		(
		isnull(coalesce(DRAFTCUST.ShipDate,DELCUST.ShipDate),'') <= GETDATE() - coalesce("OCRD"."U_V33_ShipFrequency", OCRDPDMX."U_V33_ShipFrequency") 
		and
		isnull(coalesce(DELCUST.ShipDate,DRAFTCUST.ShipDate),'') <= GETDATE() - coalesce("OCRD"."U_V33_ShipFrequency", OCRDPDMX."U_V33_ShipFrequency") 
		)


	AND
	(
	--Wave exist and not ready then the checks don't matter.
		"PMX_PLHE"."ShipToAddress" IN (select "PMX_PLHE"."ShipToAddress" FROM "PMX_PLHE" 
		INNER JOIN "PMX_WAVE" ON "PMX_PLHE"."WaveKey" = "PMX_WAVE"."InternalKey"
		WHERE "PMX_WAVE"."DocStatus" = 'O' AND "PMX_PLHE"."PickListStatus" = 'N' AND "PMX_PLHE"."WaveKey" NOT IN 
		(SELECT "PMX_PLHE"."WaveKey" FROM "PMX_PLHE" WHERE "PMX_PLHE"."DocStatus" = 'O' AND "PMX_PLHE"."PickListStatus" <> 'N') GROUP BY "PMX_PLHE"."WaveKey", "PMX_PLHE"."CardCode", "PMX_PLHE"."ShipToAddress")

	OR
	--No delivery and completion > minimum
		(((isnull(ORDR.U_Completion, 'Not Required') = 'Not Required' AND isnull(coalesce("OCRD"."U_V33_NotReqd", OCRDPDMX."U_V33_NotReqd"), 0) <= "SumSO"."soCompletion") OR
		(isnull(ORDR.U_Completion, 'Not Required') = 'As complete as possible' AND isnull(coalesce("OCRD"."U_V33_AsPossible", OCRDPDMX."U_V33_AsPossible"), 0) <= "SumSO"."soCompletion") OR
		(isnull(ORDR.U_Completion, 'Not Required') = 'Complete' AND isnull(coalesce("OCRD"."U_V33_Complete", OCRDPDMX."U_V33_Complete"), 0) <= "SumSO"."soCompletion") 
		)
		AND ISNULL(DEL.Docnum, -1) = -1
		--AND "SumSO"."soCount" >= coalesce("OCRD"."U_V33_BO_Min" , OCRDPDMX."U_V33_BO_Min" )
		)

	OR
	--Delivery exist for that sales order (so backorder), shipping before today-shipfreq, so lines > min row
		(
		ISNULL(DEL.Docnum, -1) <> -1 
		and isnull(del.ShipDate,'') < GETDATE() - coalesce("OCRD"."U_V33_ShipFrequency", OCRDPDMX."U_V33_ShipFrequency") 

		--- the backorder min check needs to be per BP instead of  order
		--AND "SumSO"."soCount" >= coalesce("OCRD"."U_V33_BO_Min" , OCRDPDMX."U_V33_BO_Min" )
		)

	OR
	--All quantity available
		("SumSO"."soCompletion" = 100)
	)
	

GROUP BY "PMX_PLPL"."DocEntry", "ORDR"."DocEntry", "PMX_PLPH"."CardCode", "PMX_PLPH"."ShipToAddress"
,"SumSO"."soCompletion"
,"OCRD"."U_V33_ShipFrequency", OCRDPDMX."U_V33_ShipFrequency"
, "ORDR"."U_completion"
, "OCRD"."U_V33_NotReqd", OCRDPDMX."U_V33_NotReqd"
, "OCRD"."U_V33_AsPossible", OCRDPDMX."U_V33_AsPossible"
, "OCRD"."U_V33_Complete", OCRDPDMX."U_V33_Complete"
, "OCRD"."U_V33_BO_Min" , OCRDPDMX."U_V33_BO_Min"
,SumSO.plQuantity
,SumSO.TotalQuantity
,SumSO.soCount
,"RDR1"."TargetType"
, "RDR1"."ShipDate"
, ocrd.CreditLine, ocrd.Balance,ocrd.DNotesBal, "SOVALUE".soOpenSum, del.ShipDate ,del.DocNum ,OCRD.GroupNum,PMX_PLHE.DocEntry,"SOVALUE".NumOfBolts
,DRAFTCUST.DocTotal

order by CardCode,soDocEntry


DECLARE cur CURSOR LOCAL FOR 
SELECT 
ORDERs.PLPLDocEntry
,ORDERS.soDocEntry  
,ORDERS.CardCode,
ORDERS.CreditLine,
isnull(ORDERS.CreditBalance,0),
ORDERS.soOpenSum,
ORDERS.SumNumOfBolts
from @ShippableOrders ORDERS
order by CardCode,soDocEntry



DECLARE @DocEntry INT
DECLARE @soDocEntry INT
DECLARE @CardCode NVARCHAR(15)
DECLARE @CreditLine NUMERIC(19,6)
DECLARE @CreditBalance NUMERIC(19,6)
DECLARE @soOpenSum NUMERIC(19,6)
DECLARE @CurrentCreditBalance NUMERIC(19,6)
DECLARE @CurrentCardCode NVARCHAR(15)
DECLARE @NumOfBolts INT
DECLARE @SumNumOfBolts INT

DECLARE  @OrderGroupedInfo TABLE( 
DocEntry INT, 
creditOK NVARCHAR(1), 
CreditBalance_Running NUMERIC(19,6),
PRIMARY KEY ( DocEntry ) )

DECLARE  @CustomerBoltSum TABLE( 
CardCode NVARCHAR(15),
sumNumBolts INT,
PRIMARY KEY ( CardCode ) )

SET @CurrentCreditBalance = 0
SET @CurrentCardCode = ''
SET @SumNumOfBolts = 0
	
OPEN cur
FETCH NEXT FROM cur INTO @DocEntry, @soDocEntry,@CardCode,@CreditLine,@CreditBalance,@soOpenSum,@NumOfBolts
WHILE @@FETCH_STATUS = 0
BEGIN
	
	IF @CurrentCardCode = '' and @CurrentCreditBalance = 0
	BEGIN
			SET @CurrentCreditBalance = @CreditBalance
			SET @CurrentCardCode = @CardCode			
	END

	IF @CurrentCardCode = @CardCode
	BEGIN
		IF (@CreditLine-@CurrentCreditBalance-@soOpenSum >0)
		BEGIN
			SET @CurrentCreditBalance = @CurrentCreditBalance + @soOpenSum
			IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry, 'Y', @CurrentCreditBalance )
			SET @SumNumOfBolts = @SumNumOfBolts+@NumOfBolts

		END
		ELSE 
		BEGIN
			SET @CurrentCreditBalance = @CurrentCreditBalance
			IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry, 'N',@CurrentCreditBalance )
			
		END

		

	END
	ELSE
	BEGIN
		--@CurrentCardCode <> @cardcode, switch cardcode so reset.
		IF NOT @CurrentCardCode IS NULL   INSERT INTO @CustomerBoltSum VALUES ( @CurrentCardCode, @SumNumOfBolts )
		SET @CurrentCreditBalance = @CreditBalance
		SET @CurrentCardCode = @CardCode
		SET @SumNumOfBolts = @NumOfBolts
		

		IF (@CreditLine-@CurrentCreditBalance-@soOpenSum >0)
		BEGIN
			SET @CurrentCreditBalance = @CurrentCreditBalance + @soOpenSum
			IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry, 'Y', @CurrentCreditBalance )

		END
		ELSE 
		BEGIN
			SET @CurrentCreditBalance = @CurrentCreditBalance
			IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry, 'N',@CurrentCreditBalance )

		END
		
	END
	
   
   
   FETCH NEXT FROM cur INTO @DocEntry, @soDocEntry,@CardCode,@CreditLine,@CreditBalance,@soOpenSum,@NumOfBolts
END
IF NOT @CurrentCardCode IS NULL   INSERT INTO @CustomerBoltSum VALUES ( @CurrentCardCode, @SumNumOfBolts )
CLOSE cur
DEALLOCATE cur


INSERT @tbl
 SELECT
 ORDERS.* 
  ,isnull(groupedInfo.CreditBalance_Running,0)
 ,isnull(groupedInfo.creditOK, 'N') as creditOK
 ,CustomerPLSum.sumNumBolts as sumNumBolts
 
 
 
FROM @ShippableOrders ORDERS
 left JOIN @OrderGroupedInfo AS groupedInfo ON groupedInfo."DocEntry" = ORDERS.PLPLDocEntry
 left join @CustomerBoltSum as CustomerPLSum on CustomerPLSum.CardCode = ORDERS.CardCode

	order by CardCode,soDocEntry

   RETURN
END




GO

